webpackJsonp([2],{

/***/ 118:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "validator", function() { return validator; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_babel_runtime_helpers_classCallCheck__ = __webpack_require__(120);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_babel_runtime_helpers_classCallCheck___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_babel_runtime_helpers_classCallCheck__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_babel_runtime_helpers_createClass__ = __webpack_require__(121);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_babel_runtime_helpers_createClass___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_babel_runtime_helpers_createClass__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_moment__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_moment___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_moment__);


/*
 * ID number verification v0.0.1
 * 中国身份证号验证(内地)
 * 作者 xxf1991-
 * ps:加微信请备注原因。 微信号 xxf1991-
 */


var IdValidate = function () {
  function IdValidate(areaNumber) {
    __WEBPACK_IMPORTED_MODULE_0_babel_runtime_helpers_classCallCheck___default()(this, IdValidate);

    this.areaNumber = areaNumber;
    this.errorMessage = null;
    this.area = null;
    this.birth = null;
    this.isValidateArea = !!areaNumber;
  }

  __WEBPACK_IMPORTED_MODULE_1_babel_runtime_helpers_createClass___default()(IdValidate, [{
    key: 'validate',
    value: function validate(idCard, areaNumber) {
      this.id = idCard;
      this.areaNumber = areaNumber;
      this.isValidateArea = this.isValidateArea || !!areaNumber;
      if (this.basicFormat(idCard)) {
        var res = true;
        if (idCard.length === 18) {
          res = this.id18Validate(idCard);
        }
        if (idCard.length === 15) {
          res = this.id15Validate(idCard);
        }
        if (res) {
          this.errorMessage = '验证通过';
        }
        return res;
      }
      return false;
    }
  }, {
    key: 'basicFormat',
    value: function basicFormat(idCard) {
      if (typeof idCard !== 'string') {
        this.errorMessage = '请输入一个字符串格式的身份证号';
        return false;
      }
      var len = idCard.length;
      if (len === 15 || len === 18) {
        return true;
      } else {
        this.errorMessage = '请输入一个15位或18位的身份证号';
        return false;
      }
    }
  }, {
    key: 'id18Validate',
    value: function id18Validate(idCard) {
      var res = this.id18Format(idCard);
      if (this.isValidateArea) {
        res = res && this.validateArea(idCard, this.areaNumber);
      }
      res = res && this.validateBirth(idCard);
      res = res && this.validateBit(idCard);
      return res;
    }
  }, {
    key: 'id15Validate',
    value: function id15Validate(idCard) {
      var res = this.id15Format(idCard);
      if (this.isValidateArea) {
        res = res && this.validateArea(idCard, this.areaNumber);
      }
      res = res && this.validateBirth(idCard);
      return res;
    }
  }, {
    key: 'id18Format',
    value: function id18Format(idCard) {
      var mes = '18位身份证号格式错误应该是18位数字或17位数字加X';
      if (idCard.slice(-1) !== 'X') {
        if (!/^[0-9]*$/.test(idCard)) {
          this.errorMessage = mes;
          return false;
        } else {
          return true;
        }
      } else {
        if (!/^[0-9]*$/.test(idCard.slice(0, 17))) {
          this.errorMessage = mes;
          return false;
        } else {
          return true;
        }
      }
    }
  }, {
    key: 'id15Format',
    value: function id15Format(idCard) {
      var mes = '15位身份证号格式错误应该是15位数字';
      if (!/^[0-9]*$/.test(idCard)) {
        this.errorMessage = mes;
        return false;
      } else {
        return true;
      }
    }
  }, {
    key: 'validateArea',
    value: function validateArea(idCard, areaNumber) {
      var mes = '地区编号不正确';
      var area = idCard.slice(0, 6);
      if (!areaNumber.hasOwnProperty(area)) {
        var tmp = void 0;
        tmp = idCard.slice(0, 4) + '00';
        if (!areaNumber.hasOwnProperty(tmp)) {
          tmp = idCard.slice(0, 2) + '0000';
          if (!areaNumber.hasOwnProperty(tmp)) {
            this.errorMessage = mes;
          } else {
            this.errorMessage = areaNumber[tmp] + '未知地区';
          }
        } else {
          this.errorMessage = areaNumber[tmp] + '未知地区';
        }
        return false;
      } else {
        this.area = areaNumber[area];
        return true;
      }
    }
  }, {
    key: 'validateBirth',
    value: function validateBirth(idCard) {
      var birth = idCard.length === 18 ? idCard.slice(6, 14) : idCard.slice(6, 12);
      var year = void 0,
          month = void 0,
          day = void 0;
      if (birth.length === 8) {
        year = parseInt(birth.slice(0, 4), 10);
        month = parseInt(birth.slice(4, 6), 10);
        day = parseInt(birth.slice(-2), 10);
      } else if (birth.length === 6) {
        year = parseInt('19' + birth.slice(0, 2), 10);
        month = parseInt(birth.slice(2, 4), 10);
        day = parseInt(birth.slice(-2), 10);
      } else {
        this.errorMessage = '出生日期的位数6位或8位';
        return false;
      }
      if (isNaN(month) || isNaN(day) || month > 12 || month === 0 || day > 31 || day === 0) {
        this.errorMessage = '出生日期的格式错误';
        return false;
      }
      this.birth = year + '-' + month + '-' + day;
      return true;
    }
  }, {
    key: 'validateBit',
    value: function validateBit(idCard) {
      if (idCard.length !== 18) {
        this.errorMessage = '只有18位身份证号才会验证校验码';
        return false;
      }
      var posWeight = [];
      for (var i = 18; i > 1; i--) {
        var wei = this.weight(i);
        posWeight[i] = wei;
      }

      var sum = 0;
      var arr = idCard.split('');
      for (var j = 0; j < arr.length - 1; j++) {
        sum += parseInt(arr[j], 10) * posWeight[18 - j];
      }

      var checkBit = 12 - sum % 11;
      if (checkBit === 10) {
        checkBit = 'X';
      } else if (checkBit > 10) {
        checkBit = checkBit % 11;
      }
      checkBit = typeof checkBit === 'number' ? checkBit.toString() : checkBit;

      if (checkBit !== idCard.slice(-1)) {
        this.errorMessage = '校检码错误';
        return false;
      } else {
        return true;
      }
    }
  }, {
    key: 'weight',
    value: function weight(t) {
      return Math.pow(2, t - 1) % 11;
    }
  }, {
    key: 'info',
    get: function get() {
      var sex = this.id.length === 18 ? this.id.slice(-2, -1) : this.id.slice(-1);
      return {
        sex: sex % 2 === 0 ? '女' : '男',
        birthday: this.birth,
        age: __WEBPACK_IMPORTED_MODULE_2_moment___default()().diff(__WEBPACK_IMPORTED_MODULE_2_moment___default()(this.birth), 'years'),
        address: this.area
      };
    }
  }]);

  return IdValidate;
}();

/* harmony default export */ __webpack_exports__["default"] = (IdValidate);

var validator = new IdValidate();


/***/ }),

/***/ 126:
/***/ (function(module, exports, __webpack_require__) {

var map = {
	"./af": 2,
	"./af.js": 2,
	"./ar": 9,
	"./ar-dz": 3,
	"./ar-dz.js": 3,
	"./ar-kw": 4,
	"./ar-kw.js": 4,
	"./ar-ly": 5,
	"./ar-ly.js": 5,
	"./ar-ma": 6,
	"./ar-ma.js": 6,
	"./ar-sa": 7,
	"./ar-sa.js": 7,
	"./ar-tn": 8,
	"./ar-tn.js": 8,
	"./ar.js": 9,
	"./az": 10,
	"./az.js": 10,
	"./be": 11,
	"./be.js": 11,
	"./bg": 12,
	"./bg.js": 12,
	"./bn": 13,
	"./bn.js": 13,
	"./bo": 14,
	"./bo.js": 14,
	"./br": 15,
	"./br.js": 15,
	"./bs": 16,
	"./bs.js": 16,
	"./ca": 17,
	"./ca.js": 17,
	"./cs": 18,
	"./cs.js": 18,
	"./cv": 19,
	"./cv.js": 19,
	"./cy": 20,
	"./cy.js": 20,
	"./da": 21,
	"./da.js": 21,
	"./de": 24,
	"./de-at": 22,
	"./de-at.js": 22,
	"./de-ch": 23,
	"./de-ch.js": 23,
	"./de.js": 24,
	"./dv": 25,
	"./dv.js": 25,
	"./el": 26,
	"./el.js": 26,
	"./en-au": 27,
	"./en-au.js": 27,
	"./en-ca": 28,
	"./en-ca.js": 28,
	"./en-gb": 29,
	"./en-gb.js": 29,
	"./en-ie": 30,
	"./en-ie.js": 30,
	"./en-nz": 31,
	"./en-nz.js": 31,
	"./eo": 32,
	"./eo.js": 32,
	"./es": 34,
	"./es-do": 33,
	"./es-do.js": 33,
	"./es.js": 34,
	"./et": 35,
	"./et.js": 35,
	"./eu": 36,
	"./eu.js": 36,
	"./fa": 37,
	"./fa.js": 37,
	"./fi": 38,
	"./fi.js": 38,
	"./fo": 39,
	"./fo.js": 39,
	"./fr": 42,
	"./fr-ca": 40,
	"./fr-ca.js": 40,
	"./fr-ch": 41,
	"./fr-ch.js": 41,
	"./fr.js": 42,
	"./fy": 43,
	"./fy.js": 43,
	"./gd": 44,
	"./gd.js": 44,
	"./gl": 45,
	"./gl.js": 45,
	"./gom-latn": 46,
	"./gom-latn.js": 46,
	"./he": 47,
	"./he.js": 47,
	"./hi": 48,
	"./hi.js": 48,
	"./hr": 49,
	"./hr.js": 49,
	"./hu": 50,
	"./hu.js": 50,
	"./hy-am": 51,
	"./hy-am.js": 51,
	"./id": 52,
	"./id.js": 52,
	"./is": 53,
	"./is.js": 53,
	"./it": 54,
	"./it.js": 54,
	"./ja": 55,
	"./ja.js": 55,
	"./jv": 56,
	"./jv.js": 56,
	"./ka": 57,
	"./ka.js": 57,
	"./kk": 58,
	"./kk.js": 58,
	"./km": 59,
	"./km.js": 59,
	"./kn": 60,
	"./kn.js": 60,
	"./ko": 61,
	"./ko.js": 61,
	"./ky": 62,
	"./ky.js": 62,
	"./lb": 63,
	"./lb.js": 63,
	"./lo": 64,
	"./lo.js": 64,
	"./lt": 65,
	"./lt.js": 65,
	"./lv": 66,
	"./lv.js": 66,
	"./me": 67,
	"./me.js": 67,
	"./mi": 68,
	"./mi.js": 68,
	"./mk": 69,
	"./mk.js": 69,
	"./ml": 70,
	"./ml.js": 70,
	"./mr": 71,
	"./mr.js": 71,
	"./ms": 73,
	"./ms-my": 72,
	"./ms-my.js": 72,
	"./ms.js": 73,
	"./my": 74,
	"./my.js": 74,
	"./nb": 75,
	"./nb.js": 75,
	"./ne": 76,
	"./ne.js": 76,
	"./nl": 78,
	"./nl-be": 77,
	"./nl-be.js": 77,
	"./nl.js": 78,
	"./nn": 79,
	"./nn.js": 79,
	"./pa-in": 80,
	"./pa-in.js": 80,
	"./pl": 81,
	"./pl.js": 81,
	"./pt": 83,
	"./pt-br": 82,
	"./pt-br.js": 82,
	"./pt.js": 83,
	"./ro": 84,
	"./ro.js": 84,
	"./ru": 85,
	"./ru.js": 85,
	"./sd": 86,
	"./sd.js": 86,
	"./se": 87,
	"./se.js": 87,
	"./si": 88,
	"./si.js": 88,
	"./sk": 89,
	"./sk.js": 89,
	"./sl": 90,
	"./sl.js": 90,
	"./sq": 91,
	"./sq.js": 91,
	"./sr": 93,
	"./sr-cyrl": 92,
	"./sr-cyrl.js": 92,
	"./sr.js": 93,
	"./ss": 94,
	"./ss.js": 94,
	"./sv": 95,
	"./sv.js": 95,
	"./sw": 96,
	"./sw.js": 96,
	"./ta": 97,
	"./ta.js": 97,
	"./te": 98,
	"./te.js": 98,
	"./tet": 99,
	"./tet.js": 99,
	"./th": 100,
	"./th.js": 100,
	"./tl-ph": 101,
	"./tl-ph.js": 101,
	"./tlh": 102,
	"./tlh.js": 102,
	"./tr": 103,
	"./tr.js": 103,
	"./tzl": 104,
	"./tzl.js": 104,
	"./tzm": 106,
	"./tzm-latn": 105,
	"./tzm-latn.js": 105,
	"./tzm.js": 106,
	"./uk": 107,
	"./uk.js": 107,
	"./ur": 108,
	"./ur.js": 108,
	"./uz": 110,
	"./uz-latn": 109,
	"./uz-latn.js": 109,
	"./uz.js": 110,
	"./vi": 111,
	"./vi.js": 111,
	"./x-pseudo": 112,
	"./x-pseudo.js": 112,
	"./yo": 113,
	"./yo.js": 113,
	"./zh-cn": 114,
	"./zh-cn.js": 114,
	"./zh-hk": 115,
	"./zh-hk.js": 115,
	"./zh-tw": 116,
	"./zh-tw.js": 116
};
function webpackContext(req) {
	return __webpack_require__(webpackContextResolve(req));
};
function webpackContextResolve(req) {
	var id = map[req];
	if(!(id + 1)) // check for number or string
		throw new Error("Cannot find module '" + req + "'.");
	return id;
};
webpackContext.keys = function webpackContextKeys() {
	return Object.keys(map);
};
webpackContext.resolve = webpackContextResolve;
module.exports = webpackContext;
webpackContext.id = 126;

/***/ })

},[118]);
//# sourceMappingURL=idCardValidator.js.map